﻿@model AEWeb.ViewModels.KPI.KpiValueTargetViewModel
@using Microsoft.AspNetCore.Mvc.Localization
@inject IViewLocalizer Localizer
@{
    var culture = System.Globalization.CultureInfo.CurrentCulture.ToString();
}
<div class="ibox ">
    <div class="ibox-title">
        <a href="#" data-toggle="modal" data-target="#@Model.IdForInfoModal"><i class="fa fa-info-circle"></i></a>
        &nbsp;
        <a href="#" data-toggle="modal" data-target="#@Model.IdForOptionsModal"><i class="fa fa-eye"></i></a>
        &nbsp;
        @if (Model.Filters.Count > 0)
        {
            <a href="#" data-toggle="modal" data-target="#@Model.IdForFilterModal"><i class="fa fa-filter"></i></a>
            Html.Raw("&nbsp;");
        }
        <h5>@Model.Title</h5>
    </div>
    <div class="ibox-content">
        @if (Model.AreFiltersApplied)
        {
            <p>
                @Html.Raw(Model.FiltersApplied)
            </p>
        }

        @foreach (string category in Model.Value.Keys)
        {
            @if (Model.ChartType == KPIClassLibrary.KPI.KPIChartType.SingleValue_SingleSeries_Sparkline)
            {
                <div id="@Model.IdForChart" style="width:100%;display: block;float: left;">
                    @Html.Raw(Model.SparklineDiv(category))
                </div>
            }
            <div style="width:100%;display: block;float: left;">
                @if (category != "NONE")
                {
                    <div style ="float:left;width:100%;background-color:#f8f8f8;">
                        <small>@Model.Label[category]</small>
                    </div>
                }
                
                <div style="float:left;width:100%;">
                    <h1 class="no-margins">@Model.ValueForDisplay(category)</h1>
                </div>
                @if (Model.ShowChange)
                {
                    <div style="float:left;">
                        <div class="stat-percent font-bold @Model.ChangeCssClass(category)">
                            @Model.ChangeForDisplay(category)<i class="fa @Model.ChangeIcon(category)"></i>
                        </div>
                    </div>
                }
            </div>
        }

        @if (Model.ShowTarget)
        {
            <div class="stat-percent font-bold text-success">@Model.TargetForDisplay <i class="fa fa-bolt"></i></div>
        }
        <span class="label label-success float-right">@Model.PeriodName</span><small>Period: @Model.PeriodValue</small>
    </div>
</div>

<!-- Modal View Options -->
<div class="modal fade" id="@Model.IdForOptionsModal" data-backdrop="static" tabindex="-1" role="dialog" aria-labelledby="staticBackdropLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title">View Options</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <form role="form" action="@Url.Action("UpdateKpiUserOptions","DashboardKpi")" method="post">
                <div class="modal-body">
                    <div asp-validation-summary="ModelOnly" class="text-danger"></div>
                    <div class="form-group imageSelector">
                        @foreach (KPIClassLibrary.KPI.KPIChartType chartType in Model.SupportedChartTypes)
                        {
                            <label>
                                @Html.RadioButtonFor(model => model.ChartType, chartType.ToString())
                                <img src="@Href(Model.GetImageForChartType(chartType))" />
                            </label>
                        }
                    </div>
                    <div class="form-group">
                        @Html.TextBoxFor(model => model.NumberOfPeriods, new { @class = "form-control" })
                    </div>
                </div>
                <div class="modal-footer">
                    <button id="@Model.IdForButtonSave" type="submit" class="btn btn-primary">Apply</button>
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                </div>
                @Html.HiddenFor(model => model.KpiId)
                @Html.HiddenFor(model => model.DashboardRowId)
                @Html.HiddenFor(model => model.DashboardId)
                @Html.HiddenFor(model => model.DashboardKpiId)
            </form>
        </div>
    </div>
</div>

<!-- Filter Modal -->
<div class="modal fade" id="@Model.IdForFilterModal" data-backdrop="static" tabindex="-1" role="dialog" aria-labelledby="staticBackdropLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title">Filter Options</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <form role="form" action="@Url.Action("UpdateKpiFilterOptions","DashboardKpi")" method="post">
                <div class="modal-body">
                    <p>
                        @Html.Raw(Model.FiltersApplied)
                    </p>
                    <div asp-validation-summary="ModelOnly" class="text-danger"></div>
                    @foreach (KPIClassLibrary.KPI.KPIFilterType filterType in Model.Filters)
                    {
                        <div class="form-group">

                            <label>Select @filterType.ToString()</label>
                            @{
                                var idoption = 0;
                            }


                            @if (filterType == KPIClassLibrary.KPI.KPIFilterType.Region)
                                @foreach (AEWeb.ViewModels.KPI.KpiFilterOption objOption in Model.FilterRegions)
                                {
                                    idoption++;
                                    <div class="form-check">
                                        <input name="RegionsApplied" class="form-check-input" type="checkbox" value="@objOption.Value" id="regioncheck_@idoption">
                                        <label class="form-check-label" for="regioncheck_@idoption">@objOption.Text</label>
                                    </div>
                                }
                            @if (filterType == KPIClassLibrary.KPI.KPIFilterType.Office)
                                @foreach (AEWeb.ViewModels.KPI.KpiFilterOption objOption in Model.FilterOffices)
                                {
                                    idoption++;
                                    <div class="form-check">
                                        <input name="OfficesApplied" class="form-check-input" type="checkbox" value="@objOption.Value" id="officecheck_@idoption">
                                        <label class="form-check-label" for="officecheck_@idoption">@objOption.Text</label>
                                    </div>
                                }
                            @if (filterType == KPIClassLibrary.KPI.KPIFilterType.TaxPayerSegment)
                                @foreach (AEWeb.ViewModels.KPI.KpiFilterOption objOption in Model.FilterSegments)
                                {
                                    idoption++;
                                    <div class="form-check">
                                        <input name="TaxPayerSegmentsApplied" class="form-check-input" type="checkbox" value="@objOption.Value" id="segmentcheck_@idoption">
                                        <label class="form-check-label" for="segmentcheck_@idoption">@objOption.Text</label>
                                    </div>
                                }
                        </div>
                    }
                </div>
                <div class="modal-footer">
                    <button id="@Model.IdForFilterButtonSave" type="submit" class="btn btn-primary">Apply</button>
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                </div>
                @Html.HiddenFor(model => model.KpiId)
                @Html.HiddenFor(model => model.DashboardRowId)
                @Html.HiddenFor(model => model.DashboardId)
                @Html.HiddenFor(model => model.DashboardKpiId)
            </form>
        </div>
    </div>
</div>

<!-- Modal Info -->
<div class="modal fade" id="@Model.IdForInfoModal" data-backdrop="static" tabindex="-1" role="dialog" aria-labelledby="staticBackdropLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="staticBackdropLabel">@Model.Title</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                @Model.ValueDescription
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-success" data-dismiss="modal">Close</button>
            </div>
        </div>
    </div>
</div>
@if (Model.ChartType == KPIClassLibrary.KPI.KPIChartType.SingleValue_SingleSeries_Sparkline)
{
    <script type="text/javascript">
    $(document).ready(function () {
        doSparkline($('#@Model.IdForChart'), "@Model.Title");
    });
    </script>
}